package fr.irisa.cairn.jnimap.barvinok;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;

import fr.irisa.cairn.jnimap.isl.ISLPWQPolynomial;

/*** PROTECTED REGION ID(BarvinokBindings_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class BarvinokBindings extends fr.irisa.cairn.jnimap.isl.ISLPWQPolynomial  {
	
	/* @generated */
	protected BarvinokBindings(long ptr) {
		/*** PROTECTED REGION ID(BarvinokBindings_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/*** PROTECTED REGION ID(BarvinokBindings_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_map_card 
	 * 
	@take map
	 * @generated
	**/
	 public static ISLPWQPolynomial card(fr.irisa.cairn.jnimap.isl.ISLMap map) { 
		/*** PROTECTED REGION ID(static_isl_map_card) DISABLED START ***/
		ISLPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(map);
			try {
				res = ISLPWQPolynomial.build(BarvinokNative.isl_map_card(getNativePtr(map)));
			} finally {
				taken(map);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_card 
	 * 
	@take set
	 * @generated
	**/
	 public static ISLPWQPolynomial card(fr.irisa.cairn.jnimap.isl.ISLSet set) { 
		/*** PROTECTED REGION ID(static_isl_set_card) DISABLED START ***/
		ISLPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(set);
			try {
				res = ISLPWQPolynomial.build(BarvinokNative.isl_set_card(getNativePtr(set)));
			} finally {
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	
	public String toString() {
		/*** PROTECTED REGION ID(BarvinokBindings_toString) DISABLED START ***/
			return BarvinokPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
